*-----------------------------------------------------------------------------
*  taiduty.prg, hacked from update.prg
*  - updates kenshi records in dues.dbf database
*  - creates taikai.dbf (rank-sorted shinpan; age-sorted yudansha, adult, kyu)
*    and taiduty.lst
*    to mks sort on rank: sort -t # -k 1.35 -r kumi.1 >kumi.2
*    -t #           makes whole line one field, 35 means start at col 35
*    -k 1.35,1.40   specifies col 35-40 range
*    -r             reverse sort
*  - uses kenshi.mem: nxtkid, ., refage, adultBD, etc
*  - Kk: must manually change title and kenshi list generator (use Mm instead)
*------------------------------------------------------------------------------

clear all
set century on
set talk off
set status on
set bell off

* public variables (saved/restored)
public  refdate  && reference for duespaid filter (eg 1st of the year)
public  refage   && reference for age calculation (eg shinkyu date)
public  newpaid  && new duespaid date for updating records
public  adultBD  && adult birthdate
public  kidBD    && kid birthdate (under 14)
public  nxtkid   && next available kenshiid
public  option   && menu selection

restore from kenshi
* refdate = ctod('1/1/96')
* refage  = ctod('7/15/97')
* newpaid = ctod('3/4/97')
* adultBD = ctod('7/15/79')
* kidBD = ctod('7/15/83')
* nxtkid = 601503
* option = ' '

* private variables (not saved/restored)
private title    && name of tournament
private promptln && end of menu display
private filt     && non-blank taikai field filter
private current  && current kenshi one-line summary
private ans      && user answer

private dojo     && dojoMenu args: dojo abbreviation
private dojname  &&   dojo name
private did      &&   dojofedid
private ad       &&   all vs single dojo

private rp       && for update: refdate
private ra       &&   refage
private dp       &&   duespaid
private kid      &&   kenshiid
private u1st     &&   usefirst
private lst      &&   lastname
private fst      &&   firstname
private mid      &&   midname
private bd       &&   birthdate
private h        &&   height string
private ht       &&   height
private wt       &&   weight
private sx       &&   sex
private r        &&   rank string
private rank     &&   rankcode
private rd       &&   rankdate
private rp       &&   rankplace
private doj      &&   
private x        &&   

private yr       && scratch: year
private mo       &&   month
private tmpno    &&   recno
private tmpname  &&   lastname for search
private tmpdate  &&   birthdate (1st of month)
private tmpdate1 &&   birthdate (1st of next month)

select b
use usadojo
set safety off
index on dojofedid to dojofedid
set safety on
goto top
select a
use dues
set relation to dojofedid into usadojo
goto top
set procedure to dfsubs

* initialize variables
*title= '2001 So Calif Kendo Championships'
title= 'Next taikai'
option = '#'     && to paint menu first time
filt = 'w'       && f=taikai filtered
current = ' '
dojo = 'all'
dojname = ' '
did = 6001
ad = .T.
x = ' '

* display current (top) entry
do updCur with current

* clear screen and put up menu (as necessary), read option
promptln = 18
do while .not. option $ '.Qq'
   if option $ ' RrDdLlCcNnPpTtOoKkMm'
      @ promptln,0 clear
      wait '['+current+']'+filt+'.  Enter option: ' to option
   else && undefined option
      clear
      @  0,1  say 'Update dues.dbf, print duty list'
      @  1,1  say title+' ('+dtoc(refage)+', adult='+dtoc(adultBD)+')'
      @  2,1  say 'Menu options:'
      @  3,15 say 'R)ef dates    Set reference dates and numbers'
      @  4,15 say 'D)ojo         Select dojo ['+dojo+']'
      @  5,15 say 'L)astname     Search by last name, whole'
      @  6,15 say 'C)ontinue     Continue search'
      @  7,15 say 'N)ext         Next entry'
      @  8,15 say 'P)revious     Previous entry'
      @  9,15 say 'E)dit         Edit and update entry'
      @ 10,15 say 'T)aikai       Update taikai field'
      @ 11,15 say 'A)ppend info  Add to taikai field'
      @ 12,15 say 'B)lank        Blank all taikai fields'
      @ 13,15 say 'F)ilter       Set filter to non-blank taikai field'
      @ 14,15 say 'brO)wse       Browse dbf'
*     @ 14,15 say 'K)enshi list  Print participant lists'
      @ 15,15 say 'M)aster list  Create TAIDUTY.DBF and TAIDUTY.LST'
      @ 16,15 say 'Q)uit         Quit'
      @ 17,15 say '.             Escape to dBASE'
      && note: set promptln above to last line + 1
      if option <> '#'
         ? chr(7) && beep
      endif
      option = ' ' && clear option, go back and prompt again
   endif
*---------
   do case
      case option $ 'Rr' && R)eference dates
         ans = 'N'
         rp = refdate
         ra = refage

         @ promptln,0 clear
         @ promptln,1    say 'Reference for duespaid filter:'
         @ promptln+1,1  say 'Reference for age calculation:'
         @ promptln+1,43 say '(adult='+dtoc(adultBD)+', kid='+dtoc(kidBD)+')'

         do while .not. ans $ 'YyQq'
            @ promptln  ,32 get rp picture '99/99/9999'
            @ promptln+1,32 get ra picture '99/99/9999'
            read
            @ promptln+4,0  clear
            wait ' Update (Y/N/Q)? ' to ans
         enddo
         if ans $ 'Yy'
            refdate = rp
            refage = ra
            yr = year(refage)
            yr = yr - 18
            adultBD = ctod(left(dtoc(refage),6) + ltrim(str(yr)))
            yr = yr + 4
            kidBD = ctod(left(dtoc(refage),6) + ltrim(str(yr)))
            option = '#'
         endif
*---------
      case option $ 'Dd' && D)ojo
         did = 0
         do dojoMenu with dojo, dojname, did, ad
         set status off
         set device to screen
         if ad
            dojo = 'all'
            if filt = 'f'
               set filter to duespaid > refdate .and. len(ltrim(trim(taikai)))>0
            else
               set filter to duespaid > refdate
            endif
         else
            if filt = 'f'
               set filter to dojofedid = did .and. duespaid > refdate .and. len(ltrim(trim(taikai)))>0
            else
               set filter to dojofedid = did .and. duespaid > refdate
            endif
         endif
         goto top
         do updCur with current
         option = "#"
*---------
      case option $ 'Ll' && L)astname
         tmpno = recno()
         tmpname = ' '
         @ promptln+1,0 clear
         accept ' Enter kenshi lastname: ' to ans
         tmpname = upper(left(ans,1))+lower(right(ans,len(ans)-1))
         set filter to
         set exact on
         filt = 'w'
         goto top
         locate for lastname = tmpname
         if found()
            do updCur with current
         else
            ? chr(7) && beep
            goto tmpno
         endif
         set exact off
*---------
      case option $ 'Cc' && C)ontinue
         tmpno = recno()
         set exact on
         continue
         if found()
            do updCur with current
         else
            ? chr(7) && beep
            goto tmpno
         endif
         set exact off
*---------
      case option $ 'Nn' && N)ext
         if eof()
            ? chr(7) && beep
         else
            skip
            do updCur with current
         endif
*---------
      case option $ 'Pp' && P)revious
         if bof()
            ? chr(7) && beep
         else
            skip -1
            do updCur with current
         endif
*---------
      case option $ 'Ee' && E)dit
         ans = 'N'
         lst = lastname
         fst = firstname
         mid = midname
         u1st = usefirst
         bd  = birthdate
         h  = ' '
         do decHt with height,h
         ht = height
         do encHt with h,ht
         wt  = weight
         sx = sex
         r = ' '
         do decRank with rankcode,r
         rank = rankcode
         do encRank with r,rank
         rd  = rankdate
         rp  = rankplace
         did = dojofedid
         dp = duespaid

         clear
         @ 0,1  say '<^end> ends screen'
         @ 1,1  say ' Last name:'
         @ 2,1  say 'First name:'
         @ 3,1  say '  Mid name:'
         @ 4,1  say '  Usefirst:'
         @ 5,1  say ' Birthdate:'          
         @ 6,1  say '    Height:'
         @ 6,20 say '('+ltrim(str(ht))+')'
         @ 7,1  say '    Weight:'
         @ 8,1  say '       Sex:'
         @ 1,35 say '      Rank:'
         @ 1,51 say '('+ltrim(str(rank))+')'
         @ 2,35 say ' Date rcvd:'
         @ 3,35 say 'Place rcvd:'
         @ 4,35 say ' Dojofedid:'
         @ 5,35 say '  Duespaid:'
         @ 6,35 say ' Last paid: '+ dtoc(duespaid)
         @ 7,35 say '  Kenshiid: '+ ltrim(str(kenshiid))

         do while .not. ans $ 'YyQq'
            @ 1,14 get lst  picture '!xxxxxxxxxxxxxx'
            @ 2,14 get fst  picture '!xxxxxxxxxxxxx'
            @ 3,14 get mid  picture '!xxxxxxxxxxxxx'
            @ 4,14 get u1st picture 'L'
            @ 5,14 get bd   picture '99/99/9999'
            @ 6,14 get h    picture "9'99"
            @ 7,14 get wt   picture '999'
            @ 8,14 get sx   picture '!'
            @ 1,47 get r    picture '9!!'
            @ 2,47 get rd   picture '99/99/9999'
            @ 3,47 get rp
            @ 4,47 get did  picture '9999'
            @ 5,47 get dp   picture '99/99/9999'
            read
            @ 9,0 clear
            wait ' Are you sure this is correct (Y/N/Q)? ' to ans
         enddo
         if ans $ 'Yy'
            set exact on
            if lst <> lastname
               replace lastname with lst
            endif
            if fst <> firstname
               replace firstname with fst
            endif
            if mid <> midname
               replace midname with mid
            endif
            replace usefirst with u1st
            if bd <> birthdate
               replace birthdate with bd
            endif
            do encHt with h,ht
            if ht <> height
               replace height with ht
            endif
            if wt <> weight
               replace weight with wt
            endif
            if sx <> sex
               replace sex with sx
            endif
            do encRank with r,rank
            if rank <> rankcode
               replace rankcode with rank
            endif
            replace rankdate with rd
            if did <> dojofedid
               replace dojofedid with did
            endif
            if dp <> duespaid
               replace duespaid with dp
            endif
            set exact off
            do updCur with current
         endif
         option = "#"
*---------
      case option $ 'Tt' && T)aikai
         ?      ' Current taikai string: ['+trim(taikai)+']'
         accept ' New taikai string (RTSWN): ' to ans
         if len(ans) > 0
            ans = upper(ans)
            replace taikai with ans
         endif
         do updCur with current
*---------
      case option $ 'Aa' && A)ppend
         accept ' Add char(s): ' to ans
         if len(ans) > 0
            ans = trim(taikai) + upper(ans)
            replace taikai with ans
         endif
         do updCur with current
*---------
      case option $ 'Bb' && B)lank
         accept ' Are you sure?' to ans
         if ans $ 'Yy'
            goto top
            do while .not. eof()
               replace taikai with "          "
               skip
            enddo
         endif
         goto top
         do updCur with current
*---------
      case option $ 'Ff' && F)ilter
         set filter to len(ltrim(trim(taikai)))>0
         goto top
         do updCur with current
         filt = 'f'
*---------
      case option $ 'Oo' && brO)wse
*        browse fiel lastname,firstname,rankcode,rankdate,birthdate,dojofedid
         browse
         option = '#'
*---------
      case option $ 'Kk' && K)enshi list: Print participant lists
         *define headers (R=ref,T=team,S=senior,W=women's,N=normal div)
         htop = ' Ŀ'
         htxt = '            NAME             RANK BIRTHDAYAGEG  HT,WT   RTSWNduty'
         hmid = ' Ĵ'
         hspc = '                                                                 '
         hbot1= ' '
*Ŀ
*          NAME              RANK BIRTHDAYAGEG  HT,WT   RTSWNduty
*Ĵ
*                                                                
*
* 2                         8 0 2 4  7         7  0  3    8    34567   1
*         10        20        30        40        50        60        70
*1234567890123456789012345678901234567890123456789012345678901234567890
         prt1st = .T.
         doj = ' '
         dojname = ' '
         all = .T.
         r = ' '
         ans = 'Y'
         wait ' Prepare printer (sethplj4), then press any key' to a

         do while ans $ 'Yy'
            set status on
            set device to print
            set margin to 0
            dojoid = 0
            do while all .or. dojoid = 0 && {loop until all req dojos done}
               do dojoMenu with doj, dojname, dojoid, all
               clear
               ? ' Printing roster for '+dojname 
               wait ' Press any key (S)kip, Q)uit):' to a
               if a $ 'Qq'
                  exit
               endif
               if .not. a $ 'Ss'
                  ? ' Printing ...'
                  htitle = title+', roster for '+doj
                  set filter to dojofedid=dojoid .and. duespaid>refdate .and. len(trim(taikai))>0
                  filt = 'w'
                  goto top
                  page = 1
                  line = 60
*hplj4:           @ 1,0 say chr(27)+"(10U"+chr(27)+"(s0p10h0s0b4099T"
                  do while .not. eof()
                     if line > 58 && {no room for new group}
                        if page = 1 
                           line = 2
                           @  line,2 say htitle
                        else
                           @ line,0 say hbot1
                           line = 2
                           @  line,2 say htitle+' (page '+ltrim(str(page))+')'
                        endif
                        @  line+1,0 say htop 
                        @  line+2,0 say htxt 
                        @  line+3,0 say hmid
                        line = line + 4
                        page = page + 1
                     else
                        @ line,0 say hmid
                        line = line + 1
                     endif 
                     @ line,0  say hspc
                     if usefirst
                        @ line,2  say upper(trim(lastname))+', '+trim(firstname)
                     else
                        @ line,2  say upper(trim(lastname))+', '+trim(midname)
                     endif
                     age = year(refage) - year(birthdate) 
                     bdThisYr=ctod(left(dtoc(birthdate),6)+ltrim(str(year(refage))))
                     if bdThisYr > refage
                        age = age - 1 
                     endif
                     if age > 0 .and. age < 100
                        set century off
                        @ line,37 say dtoc(birthdate)
                        set century on
                        if age < 10
                           @ line,48 say ltrim(str(age))
                        else
                           @ line,47 say ltrim(str(age))
                        endif
                     endif
                     do decRank with rankcode,r
                     if rankcode = 301  && {don't print year rcvd for 0 KYU}
                        @ line,32 say r
                     else
                        @ line,30 say r
                        if year(rankdate) >= 2010
                           @ line,34 say ltrim(str(year(rankdate)-2000))
                        else
                           if year(rankdate) >= 2000
                              @ line,34 say "0"
                              @ line,35 say ltrim(str(year(rankdate)-2000))
                           else
                              if year(rankdate) > 1900
                                 @ line,34 say ltrim(str(year(rankdate)-1900))
                              endif
                           endif
                        endif
                     endif
                     @ line,50 say sex
                     ft = int(height/12)
                     in = mod(height,12)
                     @ line, 53 say ltrim(str(ft))+"'"+ltrim(str(in))
                     @ line, 58 say ltrim(str(weight))
                     if AT('R',taikai)>0
                        @ line,63 say 'R'
                     endif
                     if AT('T',taikai)>0
                        @ line,64 say 'T'
                     endif
                     if AT('S',taikai)>0
                        @ line,65 say 'S'
                     endif
                     if AT('W',taikai)>0
                        @ line,66 say 'W'
                     endif
                     if AT('N',taikai)>0
                        @ line,67 say 'N'
                     endif
                     if AT('A',taikai)>0
                        @ line,71 say 'A'
                     endif
                     if AT('B',taikai)>0
                        @ line,71 say 'B'
                     endif
                     if AT('C',taikai)>0
                        @ line,71 say 'C'
                     endif
                     if AT('D',taikai)>0
                        @ line,71 say 'D'
                     endif
                     line = line + 1
                     skip
                  enddo

                  * print blanks to finish out page
                  do while line < 60
                     if line > 58 && {no room for new group}
                        @ line,0 say hbot1
                        line = 60
                     else
                        @ line,0 say hmid
                        line = line + 1
                     endif 
                     if line < 60
                        @ line,0  say hspc
                        line = line + 1
                     endif
                  enddo
                  @ 0,0 && {eject}
               endif
            enddo
            set device to screen
            set status off
            ? chr(7) && {beep}
            wait 'Do another form (Y/N)?' to ans
         enddo
         option = '#'
*---------
      case option $ 'Mm' && M)aster list: Create TAIDUTY.DBF and TAIDUTY.LST
         @ promptln,0 clear
         wait ' Create TAIDUTY.DBF (Y/N)?' to ans
         if ans $ 'Yy'
            set talk on
            set status on
            set safety off

            && write out shinpan
            filt = 'w'
            set filter to (len(trim(taikai))>0) .and. (rankcode >= 4000)
            sort to taiduty on rankcode /d,rankdate /a,birthdate /a

            && sort rest by age
            set filter to (len(trim(taikai))>0) .and. (rankcode < 4000)
            sort to tmp on birthdate /a

            && append yudansha, adults, kyu
            set safety on
            use taiduty
            append from tmp for rankcode >= 1000
            append from tmp for rankcode < 1000 .and. birthdate <= adultBD
            append from tmp for rankcode < 1000 .and. birthdate > adultBD
            set talk off
            set status off
         endif
         select b
         use usadojo index usadojo
         goto top
         select a
         use taiduty
         set relation to dojofedid into usadojo
         goto top

         ? 'Writing TAIDUTY.LST'
         set alternate to taiduty.lst
         set alternate on
         goto top
         tot = 0
         delim = 4000

t1 = '  DOJO NAME                        RANK  AGE G RTSWN D  HT/WT    ID'
t2 = '  ---- -------------------------- ------ --- - ----- - -------- ----'
*       2    7                          4 6 8   2  5 78901 3 5    0   4
*     0         10        20        30        40        50        60
         ? t1
         ? t2
         do while .not. eof()
            && print group subtotals
            && assumes shinpan, yudansha, adult, kyu groups exist in order
            if delim=4000 .and. rankcode<4000
               ? '  Total 4D+: '+ltrim(str(tot))
               ? ' '
               delim = 1000
               tot = 0
               ? t1
               ? t2
            endif
            if delim=1000 .and. rankcode<1000
               ? '  Total 1D-3D: '+ltrim(str(tot))
               ? ' '
               delim = 900
               tot = 0
               ? t1
               ? t2
            endif
            if delim=900 .and. birthdate>adultBD
               ? '  Total adult: '+ltrim(str(tot))
               ? ' '
               delim = 300
               tot = 0
               ? t1
               ? t2
            endif
            if delim=300 .and. birthdate>kidBD
               ? '  Total kyu 14+: '+ltrim(str(tot))
               ? ' '
               delim = 0
               tot = 0
               ? t1
               ? t2
            endif

            && dojo
            x = '  ' + trim(b->abbrev)
            && name
            do while len(x)<7
               x = x + ' '
            enddo
            if usefirst
               x = x + upper(trim(lastname))+', '+trim(firstname)
            else
               x = x + upper(trim(lastname))+', '+trim(midname)
            endif
            && rank
            do while len(x)<34
               x = x + ' '
            enddo
            do decRank with rankcode,r
            if rankcode = 301  && {don't print year rcvd for 0 KYU}
               x = x + '  '+r
            else
               x = x + r
               do while len(x)<38
                  x = x + ' '
               enddo
               if year(rankdate) >= 2010
                  x = x + ltrim(str(year(rankdate)-2000))
               else
                  if year(rankdate) >= 2000
                     x = x + '0'+ltrim(str(year(rankdate)-2000))
                  else
                     if year(rankdate) > 1900
                        x = x + ltrim(str(year(rankdate)-1900))
                     endif
                  endif
               endif
            endif
            && age
            do while len(x)<42
               x = x + ' '
            enddo
            age = year(refage) - year(birthdate) 
            bdThisYr=ctod(left(dtoc(birthdate),6)+ltrim(str(year(refage))))
            if bdThisYr > refage
               age = age - 1 
            endif
            if age > 0 .and. age < 100
               set century off
               set century on
               if age < 10
                  x = x + ' '+ltrim(str(age))
               else
                  x = x + ltrim(str(age))
               endif
            endif
            && sex
            do while len(x)<45
               x = x + ' '
            enddo
            x = x + sex
            && taikai participation
            do while len(x)<47
               x = x + ' '
            enddo
            if AT('R',taikai)>0
               x = x + 'R'
            else
               x = x + ' '
            endif
            if AT('T',taikai)>0
               x = x + 'T'
            else
               x = x + ' '
            endif
            if AT('S',taikai)>0
               x = x + 'S'
            else
               x = x + ' '
            endif
            if AT('W',taikai)>0
               x = x + 'W'
            else
               x = x + ' '
            endif
            if AT('N',taikai)>0
               x = x + 'N'
            else
               x = x + ' '
            endif
            do while len(x)<53
               x = x + ' '
            enddo
            if AT('A',taikai)>0
               x = x + 'A'
            else
               if AT('B',taikai)>0
                  x = x + 'B'
               else
                  if AT('C',taikai)>0
                     x = x + 'C'
                  else
                     if AT('D',taikai)>0
                        x = x + 'D'
                     else
                        x = x + ' '
                     endif
                  endif
               endif
            endif
            do while len(x)<55
               x = x + ' '
            enddo
            ft = int(height/12)
            in = mod(height,12)
            x = x + ltrim(str(ft))+"'"+ltrim(str(in))
            do while len(x)<60
               x = x + ' '
            enddo
            x = x + ltrim(str(weight))
            do while len(x)<64
               x = x + ' '
            enddo
            k = kenshiid
            if k>600000
               k = k - 600000
            endif
            if k<1000
               x = x + '0'
            endif
            if k<100
               x = x + '0'
            endif
            if k<10
               x = x + '0'
            endif
            x = x + ltrim(str(k))

            && print line
            ? x
            tot = tot + 1
            skip
         enddo
         ? '  Total kyu <14: '+ltrim(str(tot))
         close all
         select b
         use usadojo index usadojo
         goto top
         select a
         use dues
         set relation to dojofedid into usadojo
         goto top
         set procedure to dfsubs
         option = '#'
*---------
   endcase
enddo

*-------------
* termination
*-------------
set safety off
* release all && release private variables
* note: comment out above because restore doesn't preserve public?
save to kenshi
set safety on
close all
set talk on
set status on
set echo off
on escape

?    ' Remember to copy dues.dbf to kenshi.dbf!  Also, must'
wait ' regenerate dues.dbf to sort new entries properly! (enter)' to ans

if option $ 'Qq'
   quit && to DOS
else
   return && to dBASE
endif

